Amazing solution. I learned something new. Thank you Sir 😄 I know "sliding window" plus a "Hash" and a " counter" can be used to find longest subarray with k distinct elements Now you taught me that sliding window plus "min" and "max" deque can be used to find longest window with absolute difference less than k
I love that min and max queue technique with the sliding window. Also that deque technique is also used when finding the max or min value in each subarray of size K in an array O(n) time
Why can't we use min and max function to calculate min of (start and end) and max of (start and end). I am trying to understand why we need dequeue and i also know this is the right approach as my way isn't giving the right output. Here is my python code, from your algorithm, it looks like max and min changes depending on whatever the max and min value of start and end variable is maxim,minim = nums[0],nums[0] maxlen = 0 start,end = 0,0 while end < len(nums): maxim = max(nums[start],nums[end]) minim = min(nums[start],nums[end]) if (maxim-minim) > limit: start += 1 else: end +=1 maxlen = end-start+1 return maxlen
Why time complexity of deletion considered to be O(1) for deleting multiple elements from the deques. What if there are N elements to removed from the deque?
@Lead Coding Why are we incrementing s by only 1 at everystep. Other sliding window problems we tend to squeez the sliding window by continiously increamenting s by 1.
Finally have the answer. This took me forever to understand as no one ever explained it. input: [74,42,85,81,55] limit: 4 variables at every step left pointer | minheap | maxheap| right pointer 0 [74] [-74] 0 0 [42, 74] [-74, -42] 1 1 [42, 74] [-42] 1 1 [42, 74, 85] [-85, -42] 2 2 [74, 85] [-85, -42] 2 3 [74, 85] [-42] 2 3 [74, 85, 81] [-81, -42] 3 4 [74, 85, 81] [-42] 3 4 [55, 74, 81, 85] [-55, -42] 4 [55, 74, 81, 85] [-55, -42] our answer: 1 correct answer: 2 If you look at line seven in the 'variables at every step' portion you will see if we don't delete the excess numbers we will sometimes compare the wrong numbers. We should be comparing 85-81 (which is less then four) as 74 was made redundant when we added 42 to the min heap as 42 is smaller and came after 74. compare that to what should be printed at every step left pointer | minheap | maxheap| right pointer 0 [74] [74] 0 0 [42] [74, 42] 1 1 [42] [42] 1 1 [42, 85] [85] 2 2 [85] [85] 2 2 [81] [85, 81] 3 2 [55] [85, 81, 55] 4 3 [55] [81, 55] 4 4 [55] [55] 4 You can now see at line seven we are comparing 81 to 85 which is 4 which is equal to or less then our limit so the answer would be 2, the correct answer, instead of our original 1. Again the issue was because we still had redundant numbers such as 74 in our heaps that should of been removed.
think duplicates. How do u even know what is the new minimum/maximum is once the window changes? If there are multiple instances of these then it will be quite inefficient if u r iterating through the whole window to check again and again that what's the new min or max. Better to store them in some DS which is optimal.
Its an incredibly powerful technique because many interviews have difficult array problems that need to be solved in 0(n) time. Please check the question "find the max or min value in each subarray of size K n an array, in O(n)" It would be mind boggling when you get the solution
@@mohammadfraz in JS var longestSubarray = function(nums, limit) { let size = 0; for (let i = 0; i < nums.length; i++) { let min = nums[i]; let max = nums[i]; for (let j = i; j < nums.length; j++) { min = Math.min(min, nums[j]); max = Math.max(max, nums[j]); if (Math.abs(min - max)
@@mohammadfraz hey thanks for this, I now know there's something like dequeus. I did find a solution with dequeues too which got accepted. github.com/black-shadows/InterviewBit-Topicwise-Solutions/blob/master/Codersbit/Longest%20Subarray%20Difference.cpp
5:16 you mean greater than one, anyway great explanation!
Amazing solution. I learned something new. Thank you Sir 😄
I know "sliding window" plus a "Hash" and a " counter" can be used to find longest subarray with k distinct elements
Now you taught me that sliding window plus "min" and "max" deque can be used to find longest window with absolute difference less than k
I love that min and max queue technique with the sliding window.
Also that deque technique is also used when finding the max or min value in each subarray of size K in an array O(n) time
OMG You are the best! I love learning this technique!
Great explanation. This is one of the harder monotonic stack/deque problems in my opinion.
Clear and concise explanation 👍🏻
Why can't we use min and max function to calculate min of (start and end) and max of (start and end). I am trying to understand why we need dequeue and i also know this is the right approach as my way isn't giving the right output. Here is my python code, from your algorithm, it looks like max and min changes depending on whatever the max and min value of start and end variable is
maxim,minim = nums[0],nums[0]
maxlen = 0
start,end = 0,0
while end < len(nums):
maxim = max(nums[start],nums[end])
minim = min(nums[start],nums[end])
if (maxim-minim) > limit:
start += 1
else:
end +=1
maxlen = end-start+1
return maxlen
such an amazing explaination, thank you!
Can we use set we insert into set begin () will give smallest and end()-1 will give maximum
Why time complexity of deletion considered to be O(1) for deleting multiple elements from the deques. What if there are N elements to removed from the deque?
Actually at most n elements will be inserted or removed in total. So it would be O(N)
What will your algorithm output for this input [10, 1, 2, 1, 7, 2] for k=5
It will be 4 , which is wrong.
Awesome explanation. Make more videos like this
Thank you Sir 😘
This should be a leetcode hard especially considering "Sliding Window Maximum" is a hard, and this problem is much more difficult than that one
thanks sir, u helped me a lot
@Lead Coding Why are we incrementing s by only 1 at everystep. Other sliding window problems we tend to squeez the sliding window by continiously increamenting s by 1.
Can also use sliding window
What if we wanna get non continuous subarray with difference less than equal to limit???
thanks for the solution. really good explanation.
Why do remove all elements at 5:49?
Finally have the answer. This took me forever to understand as no one ever explained it.
input:
[74,42,85,81,55]
limit:
4
variables at every step
left pointer | minheap | maxheap| right pointer
0 [74] [-74] 0
0 [42, 74] [-74, -42] 1
1 [42, 74] [-42] 1
1 [42, 74, 85] [-85, -42] 2
2 [74, 85] [-85, -42] 2
3 [74, 85] [-42] 2
3 [74, 85, 81] [-81, -42] 3
4 [74, 85, 81] [-42] 3
4 [55, 74, 81, 85] [-55, -42] 4
[55, 74, 81, 85] [-55, -42]
our answer: 1
correct answer: 2
If you look at line seven in the 'variables at every step' portion you will see if we don't delete the excess numbers we will sometimes compare the wrong numbers. We should be comparing 85-81 (which is less then four) as 74 was made redundant when we added 42 to the min heap as 42 is smaller and came after 74.
compare that to what should be printed at every step
left pointer | minheap | maxheap| right pointer
0 [74] [74] 0
0 [42] [74, 42] 1
1 [42] [42] 1
1 [42, 85] [85] 2
2 [85] [85] 2
2 [81] [85, 81] 3
2 [55] [85, 81, 55] 4
3 [55] [81, 55] 4
4 [55] [55] 4
You can now see at line seven we are comparing 81 to 85 which is 4 which is equal to or less then our limit so the answer would be 2, the correct answer, instead of our original 1. Again the issue was because we still had redundant numbers such as 74 in our heaps that should of been removed.
in the first explanation, if we take input [4,8,5,1,7,9] ur output is 6 but excepted is 3. u r comparing only with min and max elements.
what is the limit here?
This question was asked in Facebook screening round
No logical flow of thought process. Deques just pop up out of nowhere. Where is the recurrence relation?
Thats cos u havent practiced enuf and want everything spoon fed tat too for free
Hye bro. Good video. Enjoyed it. Pls keep making more such videos.
Sure
how to do this task using dynamic programming?
so sliding window kind of approach basically
issue is we need index corresponding to minimum and maximum , m i right? so why not just use a pair , actually i dont want to use deque
think duplicates. How do u even know what is the new minimum/maximum is once the window changes? If there are multiple instances of these then it will be quite inefficient if u r iterating through the whole window to check again and again that what's the new min or max. Better to store them in some DS which is optimal.
Amazing work sir
bhaiya what if we use stack for min and max element
it was asked in uber dsa round
my horses name is boris
What program are you using to draw?
I am using a writing tab
Software is Microsoft one note
@@mohammadfraz ty
Aren't what you are using called MonoQueues(Monotonic Queues)?
Yes
excellent video keep it up
The two deques are so simple yet the concept is hard to understand.
Its an incredibly powerful technique because many interviews have difficult array problems that need to be solved in 0(n) time.
Please check the question "find the max or min value in each subarray of size K n an array, in O(n)"
It would be mind boggling when you get the solution
Super sir🔥
Thanks ❤️
Can you please tell me how you got the hint that we have to use *deque* data structure here? Please reply asap...i have my placement test next week.
It's based on practice. You can refer to the microsoft playlist and practice questions from there, for placements
@@mohammadfraz okay. Thanks for the reply 👍
Which software you are using to write on black screen.
one note
e++ should be at the end.
}
else{
ans = max(ans, (e-s+1));
}
e++;
Good video. Side comment: Deque is pronounced just like "deck."
Thanks a lot 😊
we can actually use two variables for min and max
Can you tell how ?.
@@mohammadfraz
in JS
var longestSubarray = function(nums, limit) {
let size = 0;
for (let i = 0; i < nums.length; i++) {
let min = nums[i];
let max = nums[i];
for (let j = i; j < nums.length; j++) {
min = Math.min(min, nums[j]);
max = Math.max(max, nums[j]);
if (Math.abs(min - max)
@@pvchio this will not pass the constraints as this is O(N^2)
@@mohammadfraz hey thanks for this, I now know there's something like dequeus. I did find a solution with dequeues too which got accepted. github.com/black-shadows/InterviewBit-Topicwise-Solutions/blob/master/Codersbit/Longest%20Subarray%20Difference.cpp
:)